/*
 *  gamestructs.h
 *  lady million
 *
 *  Created by increpare on 15/08/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

class Entity: public Vector
{
	public:
		Vector size;
		virtual void draw(){};
		virtual void move(){};
		virtual void hit(int d){};
		virtual void notifyhurt(){};
		virtual ~Entity() { }
		int damaged;
		bool material;
		bool canhurt;							  //can this hurt the player on contact?
		int damage;
		Hittype hittype;
		Entity() {
			hittype=h_no;
			material=true;
			canhurt=false;
			damage=1;
		}

};
//need to add a visibility profile as well?
//and a height-width profile?
//max framecount of 20
class Animated: public Entity{
public:
	int framecount;
	int framecoords[20][2];
	BITMAP* frames[20];
	bool canhurtprofile[20];
	Hittype hittypeprofile[20];
	int timer;
	Animated(int p_x, int p_y, int inittimer, int width, int height, int a_framecount, int a_framecoords[20][2],BITMAP* a_frames[20], bool a_canhurtprofile[20], Hittype a_hittypeprofile[20])
	{
		
		x=p_x;
		y=p_y;
		size.x=width;
		size.y=height;
		hittype=hittypeprofile[0];
		canhurt=canhurtprofile[0];
		timer=inittimer;
		framecount=a_framecount;
		
		for (int i=0;i<framecount;i++)
		{
			for (int j=0;j<2;j++)
				framecoords[i][j]=a_framecoords[i][j];
			frames[i]=a_frames[i];
			canhurtprofile[i]=a_canhurtprofile[i];
			hittypeprofile[i]=a_hittypeprofile[i];
		}

	}
	void move()
	{
		timer=(timer+1)%20;
	}
	void draw()
	{
		blit(frames[timer],buffer,0,0,x+framecoords[timer][0],y+framecoords[timer][1],size.x,size.y);
	}
	
};

const int maxplatforms=100;

const int maxenemies=100;
Entity *enemies[maxenemies];
int enemycount=0;

const int maxbullets=3;
Entity *bullets[maxbullets];

const int maxentities=maxplatforms+maxenemies+maxbullets+50;
Entity *entities[maxplatforms+maxentities+10];	  //the +10 should account for explosions, bullets, &c.
int entitycount=0;

