/*
 *  main.h
 *  lady million
 *
 *  Created by increpare on 15/08/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

const int maxhealth=18;
const int sc_capoffset[2]={-8,-8};

const int s_explode=0;
const int s_fullplat=1;
const int s_halfplat=2;
const int s_jump=3;
const int s_land=4;
const int s_select=5;
const int s_shoot=6;
const int s_barriertick=7;
const int s_deflect=8;
const int s_playerhurt=9;
const int s_badpassword=10;//used
const int s_goodpassword		=11;//used
const int s_hair		=12;//used
const int s_hurtpanda		=13;//used
const int s_itemchange		=14;//used
const int s_jawsnap		=15;
const int s_milk		=16;//used
const int s_passwordchange		=17;
const int s_sadpanda		=18;//used
const int s_selectitem		=19;//used
const int s_selectstage		=20;//used
const int s_baby = 21;//used
const int s_bag = 6; //used //NEED TO ADD
const int s_teleport=22;
const int s_teleport_out=23;
//to do: sound for disappearing specimens
//NEED TO REBALANCE SOUNDS


const int flickeramount=30;
int screenblank=0;
const int blanklength=20;
//mmtitle screen stuf
int menuitem;

//when to play platform appearing/disappearing sounds
bool playhalf=false;
bool playfull=false;

int statetimer;

//used for navigating menus...space has to be relased before it can be read again
bool spacereleased;
bool zreleased;



const int tilesize=16;

const int sc_pwidth=23;
const int sc_pheight=13;


const int sc_swidth[2]={21,14};
const int sc_sheight[2]={14,23};

BITMAP *buffer;
BITMAP *background;
BITMAP *fontbmp[36];
BITMAP *mmtitlebmp;


//in-game data
BITMAP *leveltiles[15][10];
BITMAP *shottiles[5];
BITMAP *playertiles[4];
BITMAP *healthbar[2];

BITMAP *sc_leveltiles[14][10];
BITMAP *sc_playersprite[8];
BITMAP *sc_specimensprite[2];

BITMAP *panda_sprite[4][3];
BITMAP *panda_healthgauge;
BITMAP *panda_cagetiles[5][5];
BITMAP *panda_floortile;


//zeppelin stuff
BITMAP *zepimgs;
BITMAP *zepletters;


void init();
void deinit();
void initgraphics();
void drawbackground();
int playerscreencoord();
int screencoord(int y);
void deleteforboss();
void switchmusic();
void stopmusic();
void blankscreen(bool longpause=true);
void blankscreenleavemusic();
void deleteallentities();
int tileoffset(int l);

bool playerdead;
bool bossdead;
int starttimer;
int endtimer;
const int startpause=30;
const int endpause=80;

int menuflicker;

//GAME VARIABLES
int level=0;
int curyoffset;
int maxy;
int bulletcount=0;
int score=0;
int gravitytimer=0;
const int maxgravitytimer=1000;
bool mm_completed[4];
enum ApplicationStates{app_intro, app_select, app_mm,app_sc,app_panda, app_zeppelin};
enum mm_GameStates {mm_intro, mm_title, mm_password, mm_select, mm_levelintro, mm_level,mm_paused, mm_bosstransition, mm_boss, mm_bossdead,mm_outro,mm_passworddisplay, mm_getweapon};
enum sc_GameStates {sc_title, sc_level};
enum panda_GameStates {panda_title, panda_level};
enum zeppelin_GameStates {zeppelin_title, zeppelin_level};
enum Hittype {h_no, h_deflect,h_yes};

bool mm_passworddat[5];
void getpassword();
bool trysetpassword();
bool validpassword;

int oldstate;
int gamestate;
ApplicationStates appstate;
