/*
 *  pandastructs.h
 *  lady million
 *
 *  Created by increpare on 15/08/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */


int screencol;
int loc;
int printword;//0 for letter, 1 for word, 2 for colour

const int screencount=24;
const char texts[2][screencount][50] ={
{"a","b","c","d","e","f","g","h","i","k","l","m","n","o","p","q","r","s","t","v","w","x","y","z"},
{"adam","beneath","clue","different","each","fall","grace","hand","isle","kappa","last","man","now","other","park","quit","run","save","tear","voronoi","wind","xi","yoneda","zeppelin"}
};

const int glyphcount=18;
const char glyphs[glyphcount][2]={"z","e","p","p","e","l","i","n","i","s","n","o","t","a","g","a","m","e"};


void print_text_zep(const char *s,  int x, int y)
{
	int i=0;
	while (s[i]!=0)
	{
		if (chartonum(s[i])>=0)
			masked_stretch_blit(fontbmp[chartonum(s[i])],zepletters,0,0,3,5,x+12*i,y,9,15);
		i++;
	}
}



void textprint(const char *c)
{
	int n=strlen(c);
	for (int k=0;k<n;k++)
	for (int i=0;i<13;i++)
		for (int j=0;j<7;j++)
			if ((rand()%(10*n))==0)
				print_text_zep(&c[k],i*3*4,j*5*4);
}

void lettersprint()
{
	clear_to_color(zepletters,makecol(0,0,0));
	textprint(texts[(printword>0)][loc%screencount]);	
}

class Zeppelin: public Entity
	{
	public:
		Zeppelin()
		{


			if (rand()%2==0)
			{
				y=-tilesize;
				x=rand()%140;
			}
			else
			{
				x=-tilesize;
				y=rand()%100;
			}
		}
		void move()
		{
			if (rand()%5==0)
			{
				x++;
				y+=2;
			}
			if ((y>160)||(x>144))
				deleteentity(this);
		}
		void draw()
		{
				masked_stretch_blit(leveltiles[11][8],buffer,0,0,tilesize,tilesize,x,y,tilesize*2,tilesize*2);

		}
	};

void calcprint()
{
	lettersprint();
	if (loc>500)
		printword=3;
	else if (loc>(screencount*3))
	{
		if ((rand()%(500/min(loc,500)))==0)
			printword=2;
		else
			printword=1;
	}
	else if (loc>screencount)
	{
		if ((rand()%(120/min(loc,96)))==0)
			printword=1;
		else
			printword=0;
	}
	else printword=0;
}

class Zeppelin_player: public Entity
	{
		//use damage variable to store health
	public:
		bool keypressed;
		char glyph;
		int color;
		Zeppelin_player()
		{
                         
			x=5;
			y=5;
			keypressed=true;
			glyph='x';
			color=makecol(255,255,255);
			screencol=makecol(255,0,0);
			loc=0;
			printword=false;
            calcprint();
		}
		void move()
		{
			if (keypressed)
			{
				if (!(key[KEY_UP]||key[KEY_DOWN]|key[KEY_LEFT]|key[KEY_RIGHT]))
					keypressed=false;
			}
			else if (key[KEY_UP])
				{
					y--;
					keypressed=true;
					glyph='x'+rand()%2-rand()%4;
					loc=(loc+1);
					if (loc%5==0) addentity(new Zeppelin());
					calcprint();
				}
				else if (key[KEY_DOWN])
				{
						y++;
					keypressed=true;
					glyph='x'+rand()%3-rand()%2;
					loc=(loc+1);
					if (loc%5==0) addentity(new Zeppelin());
					calcprint();

				}
				else if (key[KEY_LEFT])
				{
						x--;
					keypressed=true;
					glyph='x'-rand()%2;
					loc=(loc+1);
					if (loc%5==0) addentity(new Zeppelin());
					calcprint();

				}
				else if (key[KEY_RIGHT])
				{
					glyph='x'+rand()%2;
						x++;
					keypressed=true;
					loc=(loc+1);
					if (loc%5==0) addentity(new Zeppelin());
					calcprint();

				}
			
			if (y>6)
			{
				y=0;
		//		screeny=(screeny+1)%5;
			}
				else if (y<0) 
				{
					y=6;
		//			screeny=(screeny+4)%5;	
				}
			if (x>12) 
			{
				x=0;
		//		screenx=(screenx+1)%5;
			}
			else if (x<0) 				{
				x=12;
		//		screenx=(screenx+4)%5;	
			}
		}
		void draw()
		{

			if (printword>1)
				stretch_blit(zepimgs,buffer,0,14*(loc%screencount),16,14,0,0,160,144);

			if (printword!=2)
				blit(zepletters,buffer,0,0,0,0,160,144);
			
			print_text(glyphs[(loc+(rand()%50==0))%glyphcount],x*3*4,y*5*4);

		}
	};




